program Primes;
	type
		ListRef = ^List;

		List = record
			current : integer;
			next : ListRef;
			end;

	var result : ListRef;

	(* Build a list of integers ranging from min to max *)
	function Range(min, max: integer) : ListRef;
		var list : ListRef;
		begin
			New(list);

			if min = max then
				list^.current := max

			else begin
				list^.current := min;
				list^.next := Range(min + 1, max);
			end;

			Range := list;
		end;

	(* Filter all the specific factors from the list *)
	function FilterFactors(numbers : ListRef; factor : integer) : ListRef;
		var next : ListRef;
		begin
			if numbers = nil then
				FilterFactors := numbers			

			else if numbers^.current mod factor = 0 then begin
				next := numbers^.next;
				numbers^.next := nil;
				Dispose(numbers);

				FilterFactors := FilterFactors(next, factor);
			end

			else begin
				numbers^.next := FilterFactors(numbers^.next, factor);
				FilterFactors := numbers;
			end;
		end;				

	(* Remove all numbers that aren't primes *)
	function FilterPrimes(numbers : ListRef) : ListRef;
		begin
			if numbers <> nil then begin
				numbers^.next := FilterFactors(numbers^.next, numbers^.current);
				numbers^.next := FilterPrimes(numbers^.next);	
			end;
			
			FilterPrimes := numbers;
		end;

	(* Print the list *)
	procedure Print(numbers : ListRef);
		begin
			if numbers <> nil then begin
				Write(numbers^.current);
				Write(' ');

				Print(numbers^.next);
			end;
		end;

	(* Main program starts here *)
	begin
		result := FilterPrimes(Range(2, 100));
		Print(result);
		Writeln;
	end.
